Package be.ehealth.technicalconnector.utils

# Class ConfigurableFactoryHelper<T>

java.lang.Object
be.ehealth.technicalconnector.utils.ConfigurableFactoryHelper<T>

Type Parameters:
  `T` - : the type to be created by the factory.

public class ConfigurableFactoryHelper<T> extends Object
Factory framework methods.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ConfigurableFactoryHelper(String classPropertyName, String defaultClassPropertyName)`
  creates the helper with the required parameters.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `T`
  `getImplementation()`
  Creates a builder based on the given properties in the configuration or the default class property.
  `T`
  `getImplementation(boolean useCache)`
  Creates a builder based on the given properties in the configuration or the default class property.
  `T`
  `getImplementation(Map<String,Object> configParameters)`
  Creates a builder based on the given properties in the configuration or the default class property.
  `T`
  `getImplementation(Map<String,Object> hashMap, boolean usecache)`
  `T`
  `getImplementation(Map<String,Object> configParameters, boolean useCaching, boolean silent)`
  Creates a builder based on the given properties in the configuration or the default class property.
  `List<T>`
  `getImplementations()`
  `List<T>`
  `getImplementations(boolean useCache)`
  `List<T>`
  `getImplementations(boolean useCache, boolean silent)`
  `List<T>`
  `getImplementations(Map<String,Object> configParameters)`
  `List<T>`
  `getImplementations(Map<String,Object> configParameters, boolean useCache)`
  `List<T>`
  `getImplementations(Map<String,Object> configParameters, boolean useCache, boolean silent)`
  `void`
  `invalidateCache()`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ConfigurableFactoryHelper

    public ConfigurableFactoryHelper(String classPropertyName, String defaultClassPropertyName)
    creates the helper with the required parameters.
    Parameters:
      `classPropertyName` - the property in the config that indicates the builder implementation class to use
      `defaultClassPropertyName` - the full classname of the default builder implementation to use ( if the property in the config is empty )

- ## Method Details

  - ### getImplementation

    public T getImplementation() throws TechnicalConnectorException
    Creates a builder based on the given properties in the configuration or the default class property.
    Returns:
      configured builder
    Throws:
      `TechnicalConnectorException`

  - ### getImplementation

    public T getImplementation(boolean useCache) throws TechnicalConnectorException
    Creates a builder based on the given properties in the configuration or the default class property.
    Parameters:
      `useCache` - boolean indicating if result must be cached or not
    Returns:
      configured builder
    Throws:
      `TechnicalConnectorException`

  - ### getImplementation

    public T getImplementation(Map<String,Object> configParameters) throws TechnicalConnectorException
    Creates a builder based on the given properties in the configuration or the default class property.
    Returns:
      configured builder
    Throws:
      `TechnicalConnectorException`

  - ### getImplementation

    public T getImplementation(Map<String,Object> hashMap, boolean usecache) throws TechnicalConnectorException
    Throws:
      `TechnicalConnectorException`

  - ### getImplementation

    public T getImplementation(Map<String,Object> configParameters, boolean useCaching, boolean silent) throws TechnicalConnectorException
    Creates a builder based on the given properties in the configuration or the default class property.
    Returns:
      configured builder
    Throws:
      `TechnicalConnectorException`

  - ### getImplementations

    public List<T> getImplementations() throws TechnicalConnectorException
    Throws:
      `TechnicalConnectorException`

  - ### getImplementations

    public List<T> getImplementations(boolean useCache) throws TechnicalConnectorException
    Throws:
      `TechnicalConnectorException`

  - ### getImplementations

    public List<T> getImplementations(boolean useCache, boolean silent) throws TechnicalConnectorException
    Throws:
      `TechnicalConnectorException`

  - ### getImplementations

    public List<T> getImplementations(Map<String,Object> configParameters) throws TechnicalConnectorException
    Throws:
      `TechnicalConnectorException`

  - ### getImplementations

    public List<T> getImplementations(Map<String,Object> configParameters, boolean useCache) throws TechnicalConnectorException
    Throws:
      `TechnicalConnectorException`

  - ### getImplementations

    public List<T> getImplementations(Map<String,Object> configParameters, boolean useCache, boolean silent) throws TechnicalConnectorException
    Throws:
      `TechnicalConnectorException`

  - ### invalidateCache

    public void invalidateCache()